NeoRouter and Syncthing at boot time
Create start scripts in /etc/init.d/
Direct /etc/PM/sleep.d/ scripts to the /etc/init.d/ scripts
Syncthing script, NeoRouter script, followed by sleep.d scripts
Create files in the folders indicated. For the init.d files make them executable
================================================
In theinit.d/syncthing
script below replace<an_admin_username>
27 lines down with your username.
Also checkout the line preceeding that for the path to the syncthing daemon (default /usr/bin/syncthing).
===== /etc/init.d/syncthing
=====================
#! /bin/sh
### BEGIN INIT INFO
# Provides: syncthing
# Required-Start: $remote_fs $syslog
# Required-Stop: $remote_fs $syslog
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Controls Syncthing execution
# Description: Used for starting the decentralized syncthing platform
### END INIT INFO
# Author: john statler
#
# Please remove the “Author” lines above and replace them
# with your own name if you copy and modify this script.
# Do NOT “set -e”
# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC=”Syncthing decentralized file sync platform”
NAME=syncthing
DAEMON=/usr/bin/$NAME
DAEMON_ARGS=””
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
USER=<an_admin_username>
# Exit if the package is not installed
[ -x “$DAEMON” ] || exit 0
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions
#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon –start –quiet –pidfile $PIDFILE –exec $DAEMON –chuid $USER –background –test > /dev/null \
|| return 1
start-stop-daemon –start –quiet –pidfile $PIDFILE –exec $DAEMON –chuid $USER –background — \
$DAEMON_ARGS \
|| return 2
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon –stop –quiet –retry=TERM/30/KILL/5 –pidfile $PIDFILE –chuid $USER –name $NAME
RETVAL=”$?”
[ “$RETVAL” = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon –stop –quiet –oknodo –retry=0/30/KILL/5 –chuid $USER –exec $DAEMON
[ “$?” = 2 ] && return 2
# Many daemons don’t delete their pidfiles when they exit.
rm -f $PIDFILE
return “$RETVAL”
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
start-stop-daemon –stop –signal 1 –quiet –pidfile $PIDFILE –chuid $USER –name $NAME
return 0
}
case “$1” in
start)
[ “$VERBOSE” != no ] && log_daemon_msg “Starting $DESC” “$NAME”
do_start
case “$?” in
0|1) [ “$VERBOSE” != no ] && log_end_msg 0 ;;
2) [ “$VERBOSE” != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ “$VERBOSE” != no ] && log_daemon_msg “Stopping $DESC” “$NAME”
do_stop
case “$?” in
0|1) [ “$VERBOSE” != no ] && log_end_msg 0 ;;
2) [ “$VERBOSE” != no ] && log_end_msg 1 ;;
esac
;;
status)
status_of_proc “$DAEMON” “$NAME” && exit 0 || exit $?
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave ‘force-reload’ as an alias for ‘restart’.
#
#log_daemon_msg “Reloading $DESC” “$NAME”
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the “reload” option is implemented then remove the
# ‘force-reload’ alias
#
log_daemon_msg “Restarting $DESC” “$NAME”
do_stop
case “$?” in
0|1)
do_start
case “$?” in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
#echo “Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}” >&2
echo “Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}” >&2
exit 3
;;
esac
:
===== end syncthing
===========
===== /etc/init.d/nrservice
======
#!/bin/bash
### BEGIN INIT INFO
# Provides: nrservice
# Required-Start: $all
# Should-Start:
# Required-Stop:
# Should-Stop:
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Start and Stop NeoRouter client service
# Description: NeoRouter client service connects this computer into NeoRouter virtual network
# contact support@neorouter.com
### END INIT INFO
set -e
NAME=nrservice
DAEMON=/usr/bin/$NAME
test -x $DAEMON || exit 0
. /lib/lsb/init-functions
case “$1” in
start)
log_begin_msg “Starting NeoRouter client service: $NAME”
start-stop-daemon –start –background -m –pidfile /var/run/nrservice.pid –exec $DAEMON >/dev/null && log_end_msg 0 || log_end_msg 1
;;
stop)
log_begin_msg “Stopping NeoRouter client service: $NAME”
start-stop-daemon –stop –pidfile /var/run/nrservice.pid –oknodo –exec $DAEMON && log_end_msg 0 || log_end_msg 1
rm -f /var/run/nrservice.pid
;;
restart)
$0 stop
$0 start
;;
*)
log_success_msg “Usage: /etc/init.d/$0 {start|stop|restart}”
exit 1
;;
esac
exit 0
====== end nrserver.sh
=======
===== /etc/pm/00_syncthing_onresume.sh
========those are zeros ==
#! /bin/bash
case “$1” in
thaw)
su – tech -c “/etc/init.d/syncthing restart”
;;
resume)
su – tech -c “/etc/init.d/syncthing restart”
;;
esac
====== end 00_syncthing_onresume.sh
=====
===== /etc/pm/00_neorouter_onresume.sh
===
#! /bin/bash
case “$1” in
thaw)
su – tech -c “/etc/init.d/nrservice.sh restart”
;;
resume)
su – tech -c “/etc/init.d/nrservice.sh restart”
;;
esac
====== end 00_neorouter_onresume.sh
=======